# {{ ansible_managed }}

###############
# General
###############

auto lo
iface lo inet loopback
{% if lo is defined %}
    address {{ lo }}
{% endif %}

auto eth0
iface eth0
    address {{ ansible_host }}/24
    gateway {{ oob_gateway }}
    vrf mgmt

auto mgmt
iface mgmt
    address 127.0.0.1/8
    address ::1/128
    vrf-table auto

###############
# Bridge / Vlans
###############

auto bridge
iface bridge
    bridge-vlan-aware yes
    bridge-ports {{ aggregation_ports | join(' ') }}{{ ' peerlink' if mlag is defined else '' }}{{ ' glob swp1-48' if env == 'production' else ' swp1' }}
    bridge-vids {{ vlans | sort | join(' ') }}
{% if stp_treeprio is defined %}
    mstpctl-treeprio {{ stp_treeprio }}
{% endif %}
{% if not enable_omf | default(false) | bool %}
    bridge-mcsnoop 0
{% endif %}

{% if ib_mgmt is defined %}
###############
# In band mgmt
###############

auto vlan{{ ib_mgmt }}
iface vlan{{ ib_mgmt }}
    address {{ ib_mgmt_ip }}
    vlan-id {{ ib_mgmt }}
    vlan-raw-device bridge
    post-up ip route add {{ leaf_route }}

{% endif %}
{% if mlag is defined %}
###############
# MLAG
###############

auto peerlink
iface peerlink
    bond-slaves {{ mlag.members | join(' ') }}
    mtu 9216

auto peerlink.4094
iface peerlink.4094
    clagd-backup-ip {{ mlag.backup_ip }} vrf mgmt
    clagd-peer-ip linklocal
{%   if mlag.priority is defined %}
    clagd-priority {{ mlag.priority }}
{%   endif %}
    clagd-sys-mac {{ mlag.sys_mac }}

{% endif %}
{% if aggregation_ports is defined %}
####################
# Aggregation ports
####################

{%   for p in aggregation_ports %}
{%     set port = aggregation_ports[p] %}
{%     if port.mlag is defined %}
{%       for member in port.members %}
auto {{ member }}
iface {{ member }}
{%       endfor %}

{%     endif %}
auto {{ p }}
iface {{ p }}
    mtu 1500
{%     if port.mlag is defined %}
    clag-id {{ port.mlag_id }}
{%     endif %}
    bond-slaves {{ port.members | join(' ') }}

{%   endfor %}
{% endif %}
{% if env == 'production' %}
###############
# Access ports
###############
{# Update ifaces based on host_vars of the switch or use default port config -#}

{%   set ifaces = {} %}
{%   for p in range(1, 49) %}
{%     set port_name = 'swp' + p|string %}
{%     if access_ports is not none and port_name in access_ports %}
{%       set port_config = access_ports[port_name] %}
{%     else %}
{%       set port_config = default_port_config %}
{%     endif %}
{%     do ifaces.update({port_name: port_config}) %}
{%   endfor %}

{%   for port_name, pc in ifaces.items() | list %}
{%     set port_config = port_configs[pc] %}
auto {{ port_name }}
iface {{ port_name }}
    mtu 1500
    mstpctl-bpduguard yes
    mstpctl-portadminedge yes
{%     if port_config.untagged is defined and port_config.tagged is undefined %}
    bridge-access {{ port_config.untagged }}
{%     elif port_config.untagged is defined and port_config.tagged is defined and port_config.tagged|length >= 1 %}
    bridge-pvid {{ port_config.untagged }}
    bridge-vids {{ port_config.tagged | join(' ') }}
{%     endif %}

{%   endfor %}
{% else %}
###############
# Access ports
###############

auto swp1
iface swp1
    mtu 1500
    mstpctl-bpduguard yes
    mstpctl-portadminedge yes
    bridge-access 125
{% endif %}
